//Title:        Collection (interface)
//Version:      0.1
//Copyright:    Copyright (c) 1999
//Author:       Elwood Wray Johnson
//Organization: Object Data Management Group (ODMG)
//Description:  Object Definition Language (ODL)

package org.odmg.odl.metaobjects;

import java.beans.*;

public interface Collection extends Type
{
  public void setKind(CollectionKind newKind);
  public CollectionKind getKind();

  public void setMaxSize(Operand newMaxSize);
  public Operand getMaxSize();
  static final public FeatureDescriptor maxSizeInverse =
    Relationship.Inverse.getDescriptor(Operand.class, "sizeOf");

  public void setSubtype(Type newSubtype);
  public Type getSubtype();
  static final public FeatureDescriptor subtypeInverse =
    Relationship.Inverse.getDescriptor(Type.class, "collections");

  public void setOrdered(boolean newOrdered);
  public boolean isOrdered();

  public long bound();
}
