//Title:        CollectionKind (interface)
//Version:      0.1
//Copyright:    Copyright (c) 1999
//Author:       Elwood Wray Johnson
//Organization: Object Data Management Group (ODMG)
//Description:  Object Definition Language (ODL)

package org.odmg.odl.metaobjects;

public final class CollectionKind extends Enum
{
  static final public CollectionKind ckList  = new CollectionKind("list");
  static final public CollectionKind ckArray = new CollectionKind("array");
  static final public CollectionKind ckBag   = new CollectionKind("bag");
  static final public CollectionKind ckSet   = new CollectionKind("set");
  static final public CollectionKind ckDictionary = new CollectionKind("dictionary");
  private java.lang.Class collectionClass;
  private String name;

  private CollectionKind()
  {
  }

  private CollectionKind(String name)
  {
    setName(name);  
  }

  private CollectionKind(java.lang.Class collectionClass)
  {
    super();
    setCollectionClass(collectionClass);
  }

  static public java.util.Enumeration elements()
  {
    return Enum.elements(ckList);
  }

  public void setCollectionClass(java.lang.Class newCollectionClass)
  {
    collectionClass = newCollectionClass;
  }

  public java.lang.Class getCollectionClass()
  {
    return collectionClass;
  }

  public void setName(String newName)
  {
    name = newName;
  }

  public String getName()
  {
    return name;
  }
}


