//Title:        Constant (interface)
//Version:      0.1
//Copyright:    Copyright (c) 1999
//Author:       Elwood Wray Johnson
//Organization: Object Data Management Group (ODMG)
//Description:  Object Definition Language (ODL)

package org.odmg.odl.metaobjects;

import java.beans.*;
import org.odmg.oml.*;

public interface Constant extends MetaObject
{
  public void setHasValue(Operand newResult);
  public Operand getHasValue();
  static final public FeatureDescriptor hasValueInverse =
    Relationship.Inverse.getDescriptor(Operand.class, "valueOf");

  public void setType(Type newType);
  public Type getType();
  static final public FeatureDescriptor typeInverse =
    Relationship.Inverse.getDescriptor(Type.class, "constants");

  public void setReferencedBy(DSet newReferencedBy);
  public DSet getReferencedBy();
  static final public FeatureDescriptor referencedByInverse =
    Relationship.Inverse.getDescriptor(ConstOperand.class, "references");

  public Enumeration getEnumeration();
  public void setEnumeration(Enumeration newEnumeration);
  static final public FeatureDescriptor enumerationInverse =
    Relationship.Inverse.getDescriptor(Enumeration.class, "elements");

  public java.lang.Object value();
}
