//Title:        DefiningScope (interface)
//Version:      0.1
//Copyright:    Copyright (c) 1999
//Author:       Elwood Wray Johnson
//Organization: Object Data Management Group (ODMG)
//Description:  Object Definition Language (ODL)

package org.odmg.odl.metaobjects;

import java.beans.*;
import org.odmg.oml.*;

public interface DefiningScope extends Scope
{
  public final class InvalidType extends java.lang.Exception
  {
    public InvalidType(String reason)
    {
    	super(reason);
    }
  }
  public final class InvalidExpression extends java.lang.Exception
  {
    public InvalidExpression(String reason)
    {
    	super(reason);
    }
  }
  public DList getDefines();
  public void setDefines(DList newDefines);
    static final public FeatureDescriptor definesInverse =
      Relationship.Inverse.getDescriptor(MetaObject.class, "definedIn");
  public PrimitiveType createPrimitiveType(PrimitiveKind kind) throws Scope.DuplicateName;
  public Collection createCollectionType(CollectionKind kind, Operand maxSize, Type subType);
  public Operand createOperand(String expression) throws InvalidExpression;
  public Member createMember(String memberName, Type memberType);
  public UnionCase createCase(String caseName,  Type caseType, Operand[] caseLabels) throws Scope.DuplicateName, InvalidType;
  public Constant addConstant(String name, Operand value) throws Scope.DuplicateName;
  public TypeDefinition addTypedef(String name, Type alias) throws Scope.DuplicateName;
  public Enumeration addEnumeration(String name, String[] elementNames) throws Scope.DuplicateName;
  public Structure addStructure(String name, Member[] fields) throws Scope.DuplicateName, InvalidType;
  public Union addUnion(String name, Type switchType, UnionCase[] cases) throws Scope.DuplicateName, InvalidType;
  public Exception addException(String name, Structure result) throws Scope.DuplicateName;
  public void removeConstant(Constant constant) throws CannotRemove;
  public void removeTypedef(TypeDefinition typedef) throws CannotRemove;
  public void removeEnumeration(Enumeration enumeration) throws CannotRemove;
  public void removeStructure(Structure structure) throws CannotRemove;
  public void removeUnion(Union union) throws CannotRemove;
  public void removeException(Exception exception) throws CannotRemove;
}
