//Title:        Module (interface)
//Version:      0.1
//Copyright:    Copyright (c) 1999
//Author:       Elwood Wray Johnson
//Organization: Object Data Management Group (ODMG)
//Description:  Object Definition Language (ODL)

package org.odmg.odl.metaobjects;

import java.util.*;
import org.odmg.oml.*;

public interface Module extends MetaObject, DefiningScope
{
  Module addModule(String name) throws Scope.DuplicateName;
  void removeModule(Module object) throws CannotRemove;
  Interface addInterface(String name, List inherits) throws Scope.DuplicateName;
  void removeInterface(Interface object) throws CannotRemove;
  Class addClass(String name, List inherits,
    org.odmg.odl.metaobjects.Class extender) throws Scope.DuplicateName;
  void removeClass(Class object) throws CannotRemove;
}
