//Title:        Operand (interface)
//Version:      0.1
//Copyright:    Copyright (c) 1999
//Author:       Elwood Wray Johnson
//Organization: Object Data Management Group (ODMG)
//Description:  Object Definition Language (ODL)

package org.odmg.odl.metaobjects;

import java.beans.*;
import org.odmg.oml.*;

public interface Operand extends DObject
{
  public void setOperandIn(Expression newOperandIn);
  public Expression getOperandIn();
  static final public FeatureDescriptor operandInInverse =
    Relationship.Inverse.getDescriptor(Expression.class, "hasOperands");

  public void setValueOf(Constant newValueOf);
  public Constant getValueOf();
  static final public FeatureDescriptor valueOfInverse =
    Relationship.Inverse.getDescriptor(Constant.class, "hasValue");

  public void setSizeOf(Collection newSizeOf);
  public Collection getSizeOf();
  static final public FeatureDescriptor sizeOfInverse =
    Relationship.Inverse.getDescriptor(Collection.class, "maxSize");

  public void setCaseIn(UnionCase newCaseIn);
  public UnionCase getCaseIn();
  static final public FeatureDescriptor caseInInverse =
    Relationship.Inverse.getDescriptor(UnionCase.class, "caseLabels");

  java.lang.Object value();
}
