//Title:        Operation (interface)
//Version:      0.1
//Copyright:    Copyright (c) 1999
//Author:       Elwood Wray Johnson
//Organization: Object Data Management Group (ODMG)
//Description:  Object Definition Language (ODL)

package org.odmg.odl.metaobjects;

import java.beans.*;
import org.odmg.oml.*;

public interface Operation extends ScopedMetaObject
{
  public DList getSignature();
  public void setSignature(DList newList);
  static final public FeatureDescriptor signatureInverse =
    Relationship.Inverse.getDescriptor(Parameter.class, "operation");

  public Type getResult();
  public void setResult(Type newResult);
  static final public FeatureDescriptor resultInverse =
    Relationship.Inverse.getDescriptor(Type.class, "operations");

  public DList getExceptions();
  public void setExceptions(DList newList);
  static final public FeatureDescriptor exceptionsInverse =
    Relationship.Inverse.getDescriptor(Exception.class, "operations");
}
