//Title:        Relationship (interface)
//Version:      0.1
//Copyright:    Copyright (c) 1999
//Author:       Elwood Wray Johnson
//Organization: Object Data Management Group (ODMG)
//Description:  Object Definition Language (ODL)

package org.odmg.odl.metaobjects;

import java.beans.*;

public interface Relationship extends Property
{
  class IntegrityError extends java.lang.Exception {}
  
  public Relationship getTraversal();
  public void setTraversal(Relationship newTraversal);
  static final public FeatureDescriptor traversalInverse =
    Relationship.Inverse.getDescriptor(Relationship.class, "traversal");

  public Cardinality getCardinality();
  public void setCardinality(Cardinality newCardinality);

  class Inverse
  {
    static public FeatureDescriptor getDescriptor(
      java.lang.Class theClass)
    {
      try
      {
        return Introspector.getBeanInfo(theClass).getBeanDescriptor();
      }
      catch (IntrospectionException iex)
      {
        iex.printStackTrace();
        return null;
      }
    }

    static public FeatureDescriptor getDescriptor(
      java.lang.Class theClass, String theName)
    {
      try
      {
        PropertyDescriptor properties[] =
          Introspector.getBeanInfo(theClass).getPropertyDescriptors();
        for (int i = 0; i < properties.length; ++i)
        {
          if (properties[i].getName().equals(theName))
            return properties[i];
        }
      }
      catch (IntrospectionException iex)
      {
        iex.printStackTrace();
      }
      return null;
    }
  }
}
