//Title:        Type (interface)
//Version:      0.1
//Copyright:    Copyright (c) 1999
//Author:       Elwood Wray Johnson
//Organization: Object Data Management Group (ODMG)
//Description:  Object Definition Language (ODL)

package org.odmg.odl.metaobjects;

import java.beans.*;
import org.odmg.oml.*;

public interface Type extends MetaObject
{
  public DSet getCollections();
  public void setCollections(DSet newCollections);
  static final public FeatureDescriptor collectionsInverse =
    Relationship.Inverse.getDescriptor(Collection.class, "subtype");

  public DSet getSpecifiers();
  public void setSpecifiers(DSet newSpecifiers);
  static final public FeatureDescriptor specifiersInverse =
    Relationship.Inverse.getDescriptor(Specifier.class, "type");

  public DSet getUnions();
  public void setUnions(DSet newUnions);
  static final public FeatureDescriptor unionsInverse =
    Relationship.Inverse.getDescriptor(Union.class, "switchType");

  public DSet getOperations();
  public void setOperations(DSet newOperations);
  static final public FeatureDescriptor operationsInverse =
    Relationship.Inverse.getDescriptor(Operation.class, "result");

  public DSet getProperties();
  public void setProperties(DSet newProperties);
  static final public FeatureDescriptor propertiesInverse =
    Relationship.Inverse.getDescriptor(Property.class, "type");

  public DSet getConstants();
  public void setConstants(DSet newConstants);
  static final public FeatureDescriptor constantsInverse =
    Relationship.Inverse.getDescriptor(Constant.class, "type");

  public DSet getTypeDefs();
  public void setTypeDefs(DSet newTypeDefs);
  static final public FeatureDescriptor typeDefsInverse =
    Relationship.Inverse.getDescriptor(TypeDefinition.class, "alias");
}
