//Title:        ODMGException (interface)
//Version:      0.1
//Copyright:    Copyright (c) 1998
//Author:       Elwood Wray Johnson
//Organization: Object Data Management Group (ODMG)
//Description:  Object Manipulation Language (OML)

package org.odmg.oml;

import org.odmg.odl.metaobjects.*;

public interface DObject
{
  public final class LockType extends Enum implements Cloneable
  {
    static final public LockType read    = new LockType();
    static final public LockType write   = new LockType();
    static final public LockType upgrade = new LockType();
  }
  public final class LockNotGranted extends java.lang.Exception {}
  public void lock(LockType mode) throws LockNotGranted;
  public boolean tryLock(LockType mode);
  public boolean sameAs(DObject anObject);
  public DObject copy();
  public void delete();
}
